package org.itqop.hubmcutils.command.list;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.CommandDispatcher;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.network.chat.ClickEvent;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.HoverEvent;
import net.minecraft.network.chat.Style;
import net.minecraft.server.level.ServerPlayer;

import java.util.HashSet;
import java.util.Set;

public class PlayerActions {

    private static final Set<String> pendingConfirmation = new HashSet<>();

    public static void registerCommands(CommandDispatcher<CommandSourceStack> dispatcher) {
        dispatcher.register(Commands.literal("suicide")
                .executes(context -> {
                    ServerPlayer player = context.getSource().getPlayerOrException();
                    String playerName = player.getName().getString();

                    pendingConfirmation.add(playerName);

                    Component confirmMessage = Component.literal("[Нажмите здесь, чтобы подтвердить]")
                            .withStyle(Style.EMPTY
                                    .withColor(0xFF5555) // Красный цвет
                                    .withClickEvent(new ClickEvent(ClickEvent.Action.RUN_COMMAND, "/suicide confirm"))
                                    .withHoverEvent(new HoverEvent(HoverEvent.Action.SHOW_TEXT, Component.literal("Подтвердите команду /suicide confirm"))));

                    player.sendSystemMessage(Component.literal("Вы уверены, что хотите покончить с собой? ").append(confirmMessage));
                    return Command.SINGLE_SUCCESS;
                })
                .then(Commands.literal("confirm")
                        .executes(context -> {
                            ServerPlayer player = context.getSource().getPlayerOrException();
                            String playerName = player.getName().getString();

                            if (pendingConfirmation.contains(playerName)) {
                                pendingConfirmation.remove(playerName);
                                player.sendSystemMessage(Component.literal("Вы приняли решение покончить с собой.").withStyle(Style.EMPTY.withColor(0xFF5555)));
                                player.setHealth(0.0F); // Устанавливаем здоровье игрока на 0 для мгновенной смерти
                                player.closeContainer(); // Закрываем окно чата или инвентаря
                                return Command.SINGLE_SUCCESS;
                            } else {
                                player.sendSystemMessage(Component.literal("Сначала используйте команду /suicide, чтобы запросить подтверждение.").withStyle(Style.EMPTY.withColor(0xFFFF55))); // Желтый цвет
                                return Command.SINGLE_SUCCESS;
                            }
                        })
                )
        );
    }
}
